/* global tinyMCE */
(function($)
{
	var media = wp.media, shortcode_string = 'myalbum';
	wp.mce = wp.mce || {};
	wp.mce.myalbum = {
		shortcode_data: {},
		template: media.template('editor-myalbum'),
		initialize: function()
		{
  		var self = this;
  		jQuery.ajax(myalbumSettings.url,
  		{
    		data: {
      		m: 'wordpress',
      		a: 'embedPreviewData',
      		apiVersion: '1.0',
      		key: this.shortcode.attrs.named.album
        },
        success: function(response)
        {
          var photo = response.domains[response.header.photo.sizes[1][4]]+response.header.photo.sizes[1][3];
          var options = {
            album: self.shortcode.attrs.named.album,
            title: response.title,
            subtitle: response.subTitle,
            photo: photo
          }
          
          self.render(self.template(options));
        },
        error: function()
        {
          var options = {
            album: self.shortcode.attrs.named.album,
            title: 'Error 404',
            subtitle: 'Album not found',
            photo: '',
            cssClass: 'error'
          }
          
          self.render(self.template(options));
        }
      });
		},
		View: { // before WP 4.2:
			template: media.template('editor-myalbum'),
			postID: $('#post_ID').val(),
			initialize: function( options ) {
				this.shortcode = options.shortcode;
				wp.mce.myalbum.shortcode_data = this.shortcode;
			},
			getHtml: function() {
				var options = this.shortcode.attrs.named;
				return this.template(options);
			}
		},
		edit: function( data ) {
			var shortcode_data = wp.shortcode.next(shortcode_string, data);
			var values = shortcode_data.shortcode.attrs.named;
			wp.mce.myalbum.popupwindow(tinyMCE.activeEditor, values);
		},
				
		// this is called from our tinymce plugin, also can call from our "edit" function above
		// wp.mce.myalbum.popupwindow(tinyMCE.activeEditor, "bird");
		popupwindow: function(editor, values, onsubmit_callback){
			values = values || [];
			if(typeof onsubmit_callback !== 'function'){
				onsubmit_callback = function( e ) {
					// Insert content when the window form is submitted (this also replaces during edit, handy!)
					var args = {
							tag     : shortcode_string,
							type    : 'single',
							attrs : {
								album    : e.data.album
							}
						};
						
					editor.insertContent( wp.shortcode.string( args ) );
				};
			}
			
			editor.windowManager.open( {
				title: 'MyAlbum',
				body: [
					{
						type: 'textbox',
						name: 'album',
						label: 'Album',
						value: values.album,
						autofocus: true
					}
				],
				onsubmit: onsubmit_callback
			} );
		}
	};
	wp.mce.views.register(shortcode_string, wp.mce.myalbum);
}(jQuery));