<?php
namespace MyAlbum;

  class Api
  {
    private static $httpCode = null;
        
    public static function get($url, $token=null)
    {
      if($token===null)
        $token = Settings::Get('token');
        
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, ROOTURL."/api/".$url);
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('MAAuthorization: AccessToken ' . $token));
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_HEADER, false);
      $bodyStr = curl_exec($ch);
      
      $headers = curl_getinfo($ch);
      curl_close($ch);
            
      if($headers['http_code']==200)
      {
        // Request succeeded
        return array(
          'status' => 200,
          'body' => $bodyStr,
          'headers' => $headers
        );
      }else
      {
        return array(
          'status' => $headers['http_code'],
          'headers' => $headers
        );
      }
    }
    
    public static function deleteCache($url)
    {
      $key = "myalbum-api-".$url;
      $group = "myalbum";
      
      delete_transient($key);
      wp_cache_delete($key, $group);
    }
    
    public static function cache($url, $expiration = 120, $persistent=true)
    {
      $key = "myalbum-api-".$url;
      $group = "myalbum";
      
      if($persistent)
      {      
        $data = get_transient($key);
        if($data===false)
        {      
          $data = self::get($url);
          set_transient($key, $data, $expiration);
          return $data;
        }
      }else
      {
        $data = wp_cache_get($key, $group);
        if($data===false)
        {
          $data = self::get($url);
          wp_cache_set($key, $data, $group, $expiration);
        }
      }
        
      return $data;
    }
  }