<?php
namespace MyAlbum;

  class AutoUpdate
  {
    public function __construct()
    {
      $this->updateURL = ROOTURL.'/wordpress/checkUpdate';
      
      $plugin_slug = plugin_basename(PLUGINFILE);
      $this->plugin_slug = $plugin_slug;
      list($t1, $t2) = explode('/', $plugin_slug);
      $this->slug = str_replace('.php', '', $t2);
            
      add_filter('pre_set_site_transient_update_plugins', array($this, 'updateCheck'));
      add_filter('plugins_api', array($this, 'checkInfo'), 10, 3);
      add_filter("upgrader_post_install", array($this, "postInstall"), 10, 3);
    }
    
    // Perform additional actions to successfully install our plugin
    public function postInstall( $true, $hook_extra, $result )
    {
      // code here
      return $result;
    }
    
    public function updateCheck($transient)
    {
      if(empty($transient->checked))
      {
        return $transient;
      }
      
      $pluginData = get_plugin_data(PLUGINFILE, false, false);
      $remoteVersion = $this->getRemote();
            
      if(version_compare($pluginData['Version'], $remoteVersion->new_version, '<'))
      {
        $transient->response[$this->plugin_slug] = $remoteVersion;
      }
      
      return $transient;
    }
    
    public function checkInfo($false, $action, $arg)
    {
      if(isset($arg->slug) && $arg->slug === $this->slug)
      {
        return $this->getRemote();
      }
      
      return false;
    }
    
  	public function getRemote($asArray = false)
  	{
  		global $wp_version;
  		$pluginData = get_plugin_data(PLUGINFILE, false, false);
  		$options = array(
        'timeout' => ((defined('DOING_CRON') && DOING_CRON) ? 30 : 5),
        'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
      );
      
      // Make the POST request
  		$request = wp_remote_get($this->updateURL.'?language='.urlencode(get_locale()).'&version='.urlencode($pluginData['Version']), $options);

  		// Check if response is valid
  		if(!is_wp_error($request) || wp_remote_retrieve_response_code($request) === 200)
  		{
    		$updateResult = wp_remote_retrieve_body($request);
    		if(!empty($updateResult))
    		{
      		$remoteVersion = json_decode($updateResult, $asArray);
      		
      		if(property_exists($remoteVersion, 'sections'))
      		{
      		  $remoteVersion->sections = (array) $remoteVersion->sections;
      		}
      		
      		if(property_exists($remoteVersion, 'banners'))
      		{
      		  $remoteVersion->banners = (array) $remoteVersion->banners;
      		}
      		
      		return $remoteVersion;
    		}
  		}
  		
  		return false;
  	}
  	
  }