<?php
namespace MyAlbum;

  class Core
  {
    function __construct()
    {      
      if(is_admin())
      {
        new AutoUpdate;
        new Settings; // Plugin settings
        new MediaLibrary; // Extends wp media library
      }
      
      new Shortcode; // Handles shortcode
      new Blocks; // GutenBerg Blocks support
      
      register_activation_hook(PLUGINFILE, array($this, 'install'));
      register_deactivation_hook(PLUGINFILE, array($this, 'uninstall'));
      
      $this->addActions();
      add_filter('plugin_action_links_myalbum/myalbum.php', array($this, 'pluginActionLinks'));
    }
        
    function addActions()
    {
      add_action('plugins_loaded', array($this, 'loadTextdomain'));
    }
        
    // Set actions links (visible links below plugin on plugins page)
    function pluginActionLinks($links)
    {
      unset($links['edit']);
      $mylinks = array(
        '<a href="' . admin_url('options-general.php?page=myalbum') . '">'.__('Settings', "myalbum").'</a>',
      );
      
      return array_merge($links, $mylinks);
    }
        
    
    // Executes only when installing plugin
    function install()
    {
    }
    
    // Executes only when deinstalling plugin
    function uninstall()
    {
      delete_transient('myalbum-tokenStatus');
      delete_option('myalbum');
    }
    
    function loadTextdomain()
    {
      load_plugin_textdomain("myalbum" , false, plugin_basename(PLUGINDIR).'/languages');
    }
  }
?>