<?php
namespace MyAlbum;

  class Shortcode
  {
    public function __construct()
    {
      add_shortcode('myalbum', array($this, 'render'));
      add_action('admin_enqueue_scripts', array($this, 'registerScripts'));  
      add_action('wp_enqueue_scripts', array($this, 'registerScripts'));
          
      add_action('admin_init', array($this, 'adminInit'));
    }
    
    function registerScripts()
    {
      $locale = substr(get_locale(), 0, 2);
      wp_register_script('myalbum-remote', ROOTURL.'/res/package/js/api-album.js?hl='.$locale, array('myalbum-local-site'), null);
      wp_register_script('myalbum-local-site', plugins_url('assets/js/site.js', PLUGINFILE), null, true);
      
      if(is_admin())
      {
        wp_register_script('myalbum-local-admin', plugins_url('assets/js/admin.js', PLUGINFILE), array('shortcode', 'wp-util', 'jquery'), false, true);
        wp_localize_script('myalbum-local-admin', 'myalbumSettings', array('url'=>ROOTURL));
      }
    }
    
    function render($atts, $content)
    {
      wp_enqueue_script('myalbum-local-site');
      wp_enqueue_script('myalbum-remote');
      
      $key = $atts['album'];
      $html  = "<div class='myalbum-embed' album='".esc_attr($key)."'></div>";
      
      return $html;
  	}
  	
  	function adminInit()
  	{
    	if(current_user_can('edit_posts') || current_user_can('edit_pages'))
      {
			  add_action('print_media_templates', array($this, 'printMediaTemplates'));
			  add_action('admin_head', array($this, 'adminHead'));
			  
			  $filePath = plugins_url('assets/css/mce.css', PLUGINFILE);
        add_editor_style($filePath);
		  }
  	}
  	
  	function adminHead()
    {
  		$current_screen = get_current_screen();
  		if (!isset($current_screen->id))
  			return;  		
  			
  		if($current_screen->base=='post')
  		  wp_enqueue_script('myalbum-local-admin');
    }
    
    function printMediaTemplates()
    {
      // TinyMCE shortcode templates
      if (!isset(get_current_screen()->id) || get_current_screen()->base!='post')
        return;
      
      include_once dirname(PLUGINFILE).'/templates/tmpl-editor-myalbum.html';
    }
  }