<?php
/**
 *
 * @wordpress-plugin
 * Plugin Name: MyAlbum - Photo Gallery
 * Plugin URI: https://myalbum.com/wordpress
 * Description: Free Fully Hosted Photo Gallery for Wordpress.
 * Version: 2.0.1
 * Author: MyAlbum
 * Author URI: https://myalbum.com/
 * License: GPL-2.0+
 * License URI: http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain: myalbum
 * Domain Path: /languages
 */

// If this file is called directly, abort.
if(!defined('WPINC'))
{
	die;
}


function myalbum_photogallery_compatible($wp = '4.0.1', $php = '5.4')
{
  global $wp_version;

  $errorMsg = array();
  $phpOk = false;
  if(version_compare(PHP_VERSION, $php, '>='))
    $phpOk = true;
    
  $wpOk = false;
  if(version_compare($wp_version, $wp, '>='))
    $wpOk = true;
    
  if($wpOk && $phpOk)
    return true;
  else
    return sprintf(__("I'm sorry, but the MyAlbum - Photo Gallery plugin requires at least PHP %s and WordPress %s or higher. Your are still on PHP %s and WordPress %s.", "myalbum"), $php, $wp, PHP_VERSION, $wp_version);
}


if(myalbum_photogallery_compatible()===true)
{
  // PHP and WordPress version compatible
  $myalbum_plugin_file = __FILE__;
  require_once('startup.php');
}else
{
  function myalbum_notice()
  {   
    ?><div class="error"><p><?php echo myalbum_photogallery_compatible(); ?></p></div><?php
  }
  
  function myalbum_deactivate()
  {
    deactivate_plugins(plugin_basename(__FILE__));
  }
  
  function myalbum_activation_prevention()
  {
    $button = sprintf("<p><a href='%s'>".__("Back")."</a></p>", admin_url("plugins.php"));
    wp_die(myalbum_photogallery_compatible().$button);
  }
  
  add_action('admin_notices', 'myalbum_notice');
  add_action('admin_init', 'myalbum_deactivate');
  register_activation_hook(__FILE__, 'myalbum_activation_prevention');
}
?>